#include "knx.hpp"

int main(int argc, char ** argv)
{
    // create configuration from command line parameters
    knx::config config(argc, argv);

    // create the connection with the given config
    knx::connection connection(config);

    // create handling threads for background processing
    knx::handle handle(connection);

    // sleep some time to let all previous information settle
    sleep(2);

    // create required variables
    std::string group("1/1/31");
    bool value = false;
    bool success = false;

    // turn given group on
    connection.set<knx::dpt_switch>(group, knx::dpt_switch::ON);

    sleep(1);

    // query value
    success = connection.get<knx::dpt_switch>(group, value);
    if (success)
        std::cout << "group " << group << " is " << knx::data_point<knx::dpt_switch>(value) << std::endl;
    else
        std::cout << "group " << group << " reading failed." << std::endl;

    sleep(1);

    // turn it off
    connection.set<knx::dpt_switch>(group, knx::dpt_switch::OFF);

    sleep(1);

    // query again
    success = connection.get<knx::dpt_switch>(group, value);

    if (success)
        std::cout << "group " << group << " is " << knx::data_point<knx::dpt_switch>(value) << std::endl;
    else
        std::cout << "group " << group << " reading failed." << std::endl;

    sleep(1);

    return 0;
}
